//--------------------------------------------------------------------------
// CommandList.h : Command IDs
//--------------------------------------------------------------------------
#ifndef CommandListH
#define CommandListH

#include <tchar.h>
#include "Define.h"
#include <cstdlib>
#if _DEBUG
#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>
#define new ::new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif
//--------------------------------------------------------------------------
// COMMAND ID
//--------------------------------------------------------------------------
//typedef enum CMDID {
enum CMDID { // 2018.4 delete typedef
	// t@Cj[
		ID_OPENFILE = 11,
		ID_ADDFILE,
		ID_OPENFOLDER,
		ID_ADDFOLDER,
		ID_OPENURL,
		ID_ADDURL,
		ID_SAVEFILE,
		ID_SAVEALLFILE,
		ID_LAMECOMMANDLINE,
		ID_EXIT,
	// ҏWj[
		ID_DELETE,
		ID_SELECTALL,
	// \j[
		ID_VIDEOSCREEN,
		ID_LYRICS,
		ID_PITCHANALYSER,
		ID_TIMESLIDER,
		ID_EXPLORER,
		ID_SPEED,
		ID_FREQ,
		ID_PITCH,
		ID_VOLUME,
		ID_PAN,
		ID_EQ,
		ID_EQ20,
		ID_EQ25,
		ID_EQ31_5,
		ID_EQ40,
		ID_EQ50,
		ID_EQ63,
		ID_EQ80,
		ID_EQ100,
		ID_EQ125,
		ID_EQ160,
		ID_EQ200,
		ID_EQ250,
		ID_EQ315,
		ID_EQ400,
		ID_EQ500,
		ID_EQ630,
		ID_EQ800,
		ID_EQ1K,
		ID_EQ1_25K,
		ID_EQ1_6K,
		ID_EQ2K,
		ID_EQ2_5K,
		ID_EQ3_15K,
		ID_EQ4K,
		ID_EQ5K,
		ID_EQ6_3K,
		ID_EQ8K,
		ID_EQ10K,
		ID_EQ12_5K,
		ID_EQ16K,
		ID_EQ20K,
		ID_TAB,
		ID_PLAYLIST,
		ID_CLOSEALL,
		ID_TOOLBAR_SIZES,
		ID_TOOLBAR_SIZEM,
		ID_TOOLBAR_SIZEL,
		ID_CUSTOMIZETOOLBAR,
	// Đj[
		ID_PLAY,
		ID_PAUSE,
		ID_STOP,
		ID_HEAD,
		ID_PREVMARKER,
		ID_PREV,
		ID_NEXTMARKER,
		ID_NEXT,
		ID_REWIND,
		ID_FORWARD,
		ID_PAUSE_RETURN1SEC,
		ID_PAUSE_RETURN2SEC,
		ID_PAUSE_RETURN3SEC,
		ID_PAUSE_RETURN5SEC,
		ID_PAUSE_RETURN10SEC,
		ID_RETURN1SEC,
		ID_RETURN2SEC,
		ID_RETURN3SEC,
		ID_RETURN5SEC,
		ID_RETURN10SEC,
		ID_FORWARD1SEC,
		ID_FORWARD2SEC,
		ID_FORWARD3SEC,
		ID_FORWARD5SEC,
		ID_FORWARD10SEC,
		ID_UPVOLUME,
		ID_DOWNVOLUME,
		ID_SLOOP,
		ID_ALOOP,
		ID_RANDOM,
		ID_CONTINUE,
		ID_SAMEARTIST,
		ID_ABLOOP_A,
		ID_ABLOOP_B,
		ID_ABLOOP_A_SETTING,
		ID_ABLOOP_B_SETTING,
		ID_MARKERPLAY,
		ID_ADDMARKER,
		ID_DELETEMARKER,
		ID_COUNTLOOP,
		ID_INSTANTLOOP,
		ID_SETPOSITIONAUTO,
	// GtFNgj[
		ID_RESETSPEED,
		ID_SPEED_50,
		ID_SPEED_60,
		ID_SPEED_70,
		ID_SPEED_80,
		ID_SPEED_90,
		ID_SPEED_100,
		ID_SPEED_110,
		ID_SPEED_120,
		ID_SPEED_130,
		ID_SPEED_140,
		ID_SPEED_150,
		ID_SPEED_160,
		ID_SPEED_170,
		ID_SPEED_180,
		ID_SPEED_190,
		ID_SPEED_200,
		ID_SPEED_250,
		ID_SPEED_300,
		ID_SPEED_350,
		ID_SPEED_400,
		ID_DOWN0_1SPEED,
		ID_DOWN1SPEED,
		ID_DOWN2SPEED,
		ID_DOWN3SPEED,
		ID_DOWN5SPEED,
		ID_DOWN10SPEED,
		ID_UP0_1SPEED,
		ID_UP1SPEED,
		ID_UP2SPEED,
		ID_UP3SPEED,
		ID_UP5SPEED,
		ID_UP10SPEED,
		ID_SPEEDDEC_0,
		ID_SPEEDDEC_1,
		ID_SPEEDDEC_2,
		ID_RESETFREQ,
		ID_FREQ_50,
		ID_FREQ_60,
		ID_FREQ_70,
		ID_FREQ_80,
		ID_FREQ_90,
		ID_FREQ_100,
		ID_FREQ_110,
		ID_FREQ_120,
		ID_FREQ_130,
		ID_FREQ_140,
		ID_FREQ_150,
		ID_FREQ_160,
		ID_FREQ_170,
		ID_FREQ_180,
		ID_FREQ_190,
		ID_FREQ_200,
		ID_FREQ_250,
		ID_FREQ_300,
		ID_FREQ_350,
		ID_FREQ_400,
		ID_DOWN0_1FREQ,
		ID_DOWN1FREQ,
		ID_DOWN2FREQ,
		ID_DOWN3FREQ,
		ID_DOWN5FREQ,
		ID_DOWN10FREQ,
		ID_UP0_1FREQ,
		ID_UP1FREQ,
		ID_UP2FREQ,
		ID_UP3FREQ,
		ID_UP5FREQ,
		ID_UP10FREQ,
		ID_FREQDEC_0,
		ID_FREQDEC_1,
		ID_FREQDEC_2,
		ID_RESETPITCH,
		ID_PITCH_F12,
		ID_PITCH_F11,
		ID_PITCH_F10,
		ID_PITCH_F9,
		ID_PITCH_F8,
		ID_PITCH_F7,
		ID_PITCH_F6,
		ID_PITCH_F5,
		ID_PITCH_F4,
		ID_PITCH_F3,
		ID_PITCH_F2,
		ID_PITCH_F1,
		ID_PITCH_0,
		ID_PITCH_S1,
		ID_PITCH_S2,
		ID_PITCH_S3,
		ID_PITCH_S4,
		ID_PITCH_S5,
		ID_PITCH_S6,
		ID_PITCH_S7,
		ID_PITCH_S8,
		ID_PITCH_S9,
		ID_PITCH_S10,
		ID_PITCH_S11,
		ID_PITCH_S12,
		ID_DOWN1PITCH,
		ID_DOWN2PITCH,
		ID_DOWN1OCTPITCH,
		ID_UP1PITCH,
		ID_UP2PITCH,
		ID_UP1OCTPITCH,
		ID_PITCHDEC_0,
		ID_PITCHDEC_1,
		ID_PITCHDEC_2,
		ID_RESETVOLUME,
		ID_VOLUME_0,
		ID_VOLUME_10,
		ID_VOLUME_20,
		ID_VOLUME_30,
		ID_VOLUME_40,
		ID_VOLUME_50,
		ID_VOLUME_60,
		ID_VOLUME_70,
		ID_VOLUME_80,
		ID_VOLUME_90,
		ID_VOLUME_100,
		ID_REVERB_DEFAULT,
		ID_REVERB_CUSTOMIZE,
		ID_3DREVERB_DEFAULT,
		ID_3DREVERB_PADDEDCELL,
		ID_3DREVERB_ROOM,
		ID_3DREVERB_BATHROOM,
		ID_3DREVERB_LIVINGROOM,
		ID_3DREVERB_STONEROOM,
		ID_3DREVERB_AUDITORIUM,
		ID_3DREVERB_CONCERTHALL,
		ID_3DREVERB_CAVE,
		ID_3DREVERB_ARENA,
		ID_3DREVERB_HANGAR,
		ID_3DREVERB_CARPETEDHALLWAY,
		ID_3DREVERB_HALLWAY,
		ID_3DREVERB_STONECORRIDOR,
		ID_3DREVERB_ALLEY,
		ID_3DREVERB_FOREST,
		ID_3DREVERB_CITY,
		ID_3DREVERB_MOUNTAINS,
		ID_3DREVERB_QUARRY,
		ID_3DREVERB_PLAIN,
		ID_3DREVERB_PARKINGLOT,
		ID_3DREVERB_SEWERPIPE,
		ID_3DREVERB_UNDERWATER,
		ID_3DREVERB_SMALLROOM,
		ID_3DREVERB_MEDIUMROOM,
		ID_3DREVERB_LARGEROOM,
		ID_3DREVERB_MEDIUMHALL,
		ID_3DREVERB_LARGEHALL,
		ID_3DREVERB_PLATE,
		ID_3DREVERB_CUSTOMIZE,
		ID_DELAY_DEFAULT,
		ID_DELAY_SHORT,
		ID_DELAY_MEDIUM,
		ID_DELAY_LONG,
		ID_DELAY_STEREOSHORT,
		ID_DELAY_STEREOMEDIUM,
		ID_DELAY_STEREOLONG,
		ID_DELAY_MOUNTAIN,
		ID_DELAY_BIG,
		ID_DELAY_STEREOBIG,
		ID_DELAY_DOUBLING,
		ID_DELAY_DOUBLEKICK,
		ID_DELAY_CUSTOMIZE,
		ID_CHORUS_DEFAULT,
		ID_CHORUS_CUSTOMIZE,
		ID_COMPRESSOR_DEFAULT,
		ID_COMPRESSOR_CUSTOMIZE,
		ID_FLANGER_DEFAULT,
		ID_FLANGER_CUSTOMIZE,
		ID_GARGLE_DEFAULT,
		ID_GARGLE_CUSTOMIZE,
		ID_DISTORTION_DEFAULT,
		ID_DISTORTION_CUSTOMIZE,
		ID_EQFLAT,
		ID_EQLOWSUPER,
		ID_EQLOWHIGHEST,
		ID_EQLOWHIGH,
		ID_EQLOWMIDDLE,
		ID_EQLOWLOW,
		ID_EQLOWLOWEST,
		ID_EQMIDDLESUPER,
		ID_EQMIDDLEHIGHEST,
		ID_EQMIDDLEHIGH,
		ID_EQMIDDLEMIDDLE,
		ID_EQMIDDLELOW,
		ID_EQMIDDLELOWEST,
		ID_EQHIGHSUPER,
		ID_EQHIGHHIGHEST,
		ID_EQHIGHHIGH,
		ID_EQHIGHMIDDLE,
		ID_EQHIGHLOW,
		ID_EQHIGHLOWEST,
		ID_EQLOWCUTSUPER,
		ID_EQLOWCUTHIGHEST,
		ID_EQLOWCUTHIGH,
		ID_EQLOWCUTMIDDLE,
		ID_EQLOWCUTLOW,
		ID_EQLOWCUTLOWEST,
		ID_EQMIDDLECUTSUPER,
		ID_EQMIDDLECUTHIGHEST,
		ID_EQMIDDLECUTHIGH,
		ID_EQMIDDLECUTMIDDLE,
		ID_EQMIDDLECUTLOW,
		ID_EQMIDDLECUTLOWEST,
		ID_EQHIGHCUTSUPER,
		ID_EQHIGHCUTHIGHEST,
		ID_EQHIGHCUTHIGH,
		ID_EQHIGHCUTMIDDLE,
		ID_EQHIGHCUTLOW,
		ID_EQHIGHCUTLOWEST,
		ID_RECORDNOISE,
		ID_WAVE,
		ID_NORMALIZE,
		ID_VOCALCANCEL,
		ID_REVERSE,
		ID_RECORD,
		ID_LOWBATTERY,
		ID_NOSENSE,
		ID_BASSCOPY,
		ID_CYMBALCOPY,
		ID_EARTRAINING,
		ID_MONORAL,
		ID_ONLYLEFT,
		ID_ONLYRIGHT,
		ID_CHANGELR,
		ID_RESETALL,
	// VXej[
		// j[
			// \ԃj[
				ID_RECOVERVIDEOSCREENVISIBLE,
				ID_RECOVERTIMESLIDERVISIBLE,
				ID_RECOVERSPEEDVISIBLE,
				ID_RECOVERFREQVISIBLE,
				ID_RECOVERPITCHVISIBLE,
				ID_RECOVERVOLUMEVISIBLE,
				ID_RECOVERPANVISIBLE,
				ID_RECOVEREQVISIBLE,
				ID_RECOVERLISTVISIBLE,
			// Đ[hj[
				ID_RECOVERSLOOP,
				ID_RECOVERALOOP,
				ID_RECOVERRANDOM,
				ID_RECOVERCONTINUE,
				ID_RECOVERINSTANTLOOP,
				ID_RECOVERSETPOSITIONAUTO,
				ID_RECOVERREVERSE,
				ID_RECOVERRECORD,
			ID_RECOVERWPOS,
			ID_RECOVERWSIZE,
			ID_RECOVERPLAYPOS,
			ID_RECOVERSPEED,
			ID_RECOVERFREQ,
			ID_RECOVERPITCH,
			ID_RECOVERVOLUME,
			ID_RECOVERPAN,
			ID_RECOVEREQ,
			ID_RECOVERLIST,
		ID_KEYSETTING,
		ID_OUTKEYSETTING,
		ID_LIMIT,
		ID_TIMERPLAY,
		ID_PLAYRANGE,
		ID_PLAYPOSITION,
		ID_INCSPEED,
		ID_INCFREQ,
		ID_DECSPEED,
		ID_DECFREQ,
		ID_FADEOUTSTOP,
		ID_FADEOUTSTOP1SEC,
		ID_FADEOUTSTOP2SEC,
		ID_FADEOUTSTOP3SEC,
		ID_FADEOUTSTOP4SEC,
		ID_FADEOUTSTOP5SEC,
		ID_FADEOUTSTOP6SEC,
		ID_FADEOUTSTOP7SEC,
		ID_FADEOUTSTOP8SEC,
		ID_FADEOUTSTOP9SEC,
		ID_FADEOUTSTOP10SEC,
		ID_FADEOUTNEXT,
		ID_FADEOUTNEXT1SEC,
		ID_FADEOUTNEXT2SEC,
		ID_FADEOUTNEXT3SEC,
		ID_FADEOUTNEXT4SEC,
		ID_FADEOUTNEXT5SEC,
		ID_FADEOUTNEXT6SEC,
		ID_FADEOUTNEXT7SEC,
		ID_FADEOUTNEXT8SEC,
		ID_FADEOUTNEXT9SEC,
		ID_FADEOUTNEXT10SEC,
		ID_TWEET,
		ID_METRONOME,
		ID_QUALITY_NORMAL,
		ID_QUALITY_ASIO,
		ID_QUALITY_WASAPI,
		ID_DOUBLERUN,
		ID_TOPMOST,
		ID_TASKTRAY,
		ID_COPYTIME,
	// wvj[
		ID_MANUAL,
		ID_UPDATECHECK,
		ID_VERSIONINFO,
	// ̑
		ID_RESTORE,
	// vZbg
		ID_ADDPRESET,
		ID_DELETEPRESET,
		ID_PRESET,
};


//--------------------------------------------------------------------------
// DEFINITION
//--------------------------------------------------------------------------
// @\敪
#define DIV_TERMINAL    -1    // ݒ胊Xg̏I[
#define DIV_NONE        0
#define DIV_FILE        1
#define DIV_EDIT        2
#define DIV_VIEW        3
#define DIV_PLAY        4
#define DIV_BACKWARD    5
#define DIV_FORWARD     6
#define DIV_SPEED       7
#define DIV_FREQ        8
#define DIV_PITCH       9
#define DIV_SYSTEM      10
#define DIV_RECOVERY    11
#define DIV_RCV_VISIBLE 12
#define DIV_RCV_MODE    13
#define DIV_EFFECT      14
#define DIV_EQ_PRESET   15
#define DIV_HELP        16

// Lɂ rbgtO
#define CMD_NONE        0     // \Ȃ
#define CMD_SHORTCUTKEY 1     // V[gJbgL[ƂĐݒ\
#define CMD_HOTKEY      1<<1  // O[ozbgL[ƂĐݒ\
#define CMD_MENU        1<<2  // j[ڂƂĎgpi11.12.21݁A\͍sȂĂȂj
#define CMD_TOOLBAR     1<<3  // c[o[Ŏgpi11.12.21݁A\͍sȂĂȂj

#define CMD_KEYSET      (CMD_SHORTCUTKEY|CMD_HOTKEY)
#define CMD_KEYMENU     (CMD_KEYSET|CMD_MENU)
#define CMD_ALL         (CMD_KEYSET|CMD_MENU|CMD_TOOLBAR)


//--------------------------------------------------------------------------
// STRUCT
//--------------------------------------------------------------------------
typedef struct ST_CMDLIST {
	int     div;        // @\敪 DIV_*
	UINT    use;        // gp\Ƃꏊ CMD_*
	WORD    id;         // R}hID CMDID::ID_*
	TCHAR*  pszText;    // \
} *PST_CMDLIST;


//--------------------------------------------------------------------------
// CLASS
//--------------------------------------------------------------------------
class CCommandList
{
public:
	CCommandList();
	operator PST_CMDLIST(){return m_list;}
	~CCommandList(){}
	
	WORD GetCommandId(tstring str);
	tstring GetCommandName(int id);

private:
	PST_CMDLIST m_list;
};

#endif // CommandListH
