//----------------------------------------------------------------------------
// KeyInputWnd.h : L[͗pEBhE̊Ǘs
//----------------------------------------------------------------------------
#ifndef KeyInputWndH
#define KeyInputWndH

class CApp;
class CMainWnd;
class CKeySettingWnd_MainWnd;
#include "../Common/FrameWnd.h"
#include "../Common/ComboBox.h"
#include "../Common/HotKeyCtrl.h"
#include "../Common/Button.h"
#include <cstdlib>
#if _DEBUG
#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>
#define new ::new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif
//----------------------------------------------------------------------------
// zbgL[Rg[̊ǗsNX
//----------------------------------------------------------------------------
class CHotKeyCtrl_KeyInputWnd : public CHotKeyCtrl
{
public: // ֐

	CHotKeyCtrl_KeyInputWnd() { }
	virtual ~CHotKeyCtrl_KeyInputWnd() { }

	virtual void OnKeyDown(UINT vk, int cRepeat, UINT flags);
};
//----------------------------------------------------------------------------
// L[͗pEBhE̊ǗsNX
//----------------------------------------------------------------------------
class CKeyInputWnd : public CFrameWnd
{
public: // ֐

	CKeyInputWnd(CApp & app, CMainWnd & mainWnd,
				 CKeySettingWnd_MainWnd & parentWnd);
	virtual ~CKeyInputWnd();

	virtual BOOL Create(BOOL bAdd);

	virtual LRESULT OnCreate(LPCREATESTRUCT lpCreateStruct);
	virtual void OnCommand(int id, HWND hwndCtl, UINT codeNotify);
	virtual void OnDestroy();

private: // oϐ

	CApp & m_rApp;
	CMainWnd & m_rMainWnd;
	CKeySettingWnd_MainWnd & m_rParentWnd;

	CComboBox m_combo;
	CHotKeyCtrl_KeyInputWnd m_hot;
	CButton m_OkButton;
	CButton m_CancelButton;

	LPACCEL m_pAccel; // ANZ[^e[uޔp
	int m_nAccel; // ANZ[^e[uޔp
	BOOL m_bAdd; // Xgɒǉ邩ǂ

public: // oϐ̎擾Eݒ

	CHotKeyCtrl_KeyInputWnd & GetHotKeyCtrl() { return m_hot; }
	CComboBox & GetComboBox() { return m_combo; }

public: // 萔
	enum {
		ID_COMBO = 100,
		ID_HOT,
		ID_OK,
		ID_CANCEL,
	};
};
//----------------------------------------------------------------------------

#endif