//----------------------------------------------------------------------------
// Menu_MainWnd.h : CEBhEpj[̍쐬EǗs
//----------------------------------------------------------------------------
#ifndef Menu_MainWndH
#define Menu_MainWndH

class CApp;
class CMainWnd;
#include "../Common/bass_def.h"
#include "../Common/Menu.h"
#include <cstdlib>
#if _DEBUG
#define _CRTDBG_MAP_ALLOC
#include <crtdbg.h>
#define new ::new(_NORMAL_BLOCK, __FILE__, __LINE__)
#endif
//----------------------------------------------------------------------------
// CEBhEpj[̍쐬EǗsNX
//----------------------------------------------------------------------------
class CMenu_MainWnd : public CMenu
{
public: // ֐

	CMenu_MainWnd(CApp & app, CMainWnd & mainWnd)
		: m_rApp(app), m_rMainWnd(mainWnd) { }
	virtual ~CMenu_MainWnd() { }

	virtual BOOL Create();
	void SetABLoopState(BOOL bALoop, BOOL bBLoop);
	void SetFileLoadState(BOOL bLoad);
	void SetDelay(float fWetDryMix, float fFeedback, float fLeftDelay,
		float fRightDelay, BOOL lPanDelay, UINT uID);
	void SetChorus(float fWetDryMix, float fDepth, float fFeedback,
				   float fFreq, DWORD lWaveform, float fDelay, DWORD lPhase,
				   UINT uID);
	void SetCompressor(float fGain, float fAttack, float fRelease,
					   float fThreshold, float fRatio, float fPredelay,
					   UINT uID);
	void SetFlanger(float fWetDryMix, float fDepth, float fFeedback,
					float fFreq, DWORD lWaveform, float fDelay,
					DWORD lPhase, UINT uID);
	void SetGargle(DWORD dwRateHz, DWORD dwWaveShape, UINT uID);
	void SetDistortion(float fGain, float fEdge, float fPostEQCenterFreq,
					   float fPostEQBandwidth, float fPreLowpassCutoff,
					   UINT uID);
	void SetReverb(float fInGain, float fReverbMix, float fReverbTime,
		float fHighFreqRTRatio, UINT uID);
	void Set3DReverb(int lRoom, int lRoomHF, float flRoomRolloffFactor,
		float flDecayTime, float flDecayHFRatio, int lReflections,
		float flReflectionsDelay, int lReverb, float flReverbDelay,
		float flDiffusion, float flDensity, float flHFReference, UINT uID);
	void SetSingleLoopState(BOOL bSLoop);
	void SwitchEQVisible(UINT uID);
	void SwitchItemChecked(UINT uID);
	void UncheckChorusMenu();
	void UncheckCompressorMenu();
	void UncheckDelayMenu();
	void UncheckDistortionMenu();
	void UncheckFadeoutMenu();
	void UncheckFadeoutNextMenu();
	void UncheckFlangerMenu();
	void UncheckGargleMenu();
	void UncheckPresetMenu();
	void UncheckReverbMenu();
	void Uncheck3DReverbMenu();
	void UncheckSoundEffectMenu();
	void OnCommand(int id, HWND hwndCtl, UINT codeNotify);
	void OnOpenFileMenuSelected();
	void OnAddFileMenuSelected();
	void OnOpenFolderMenuSelected();
	void OnAddFolderMenuSelected();
	void OnOpenURLMenuSelected();
	void OnAddURLMenuSelected();
	void OnSaveFileMenuSelected();
	void OnSaveAllFileMenuSelected();
	void OnLAMECommandLineMenuSelected();
	void OnExitMenuSelected();
	void OnDeleteMenuSelected();
	void OnSelectAllMenuSelected();
	void OnToolbarSSizeMenuSelected();
	void OnToolbarMSizeMenuSelected();
	void OnToolbarLSizeMenuSelected();
	void OnCustomizeToolbarMenuSelected();
	void OnVideoScreenMenuSelected();
	void OnLyricsMenuSelected();
	void OnPitchAnalyserMenuSelected();
	void OnTimeSliderMenuSelected();
	void OnExplorerMenuSelected();
	void OnSpeedMenuSelected();
	void OnFreqMenuSelected();
	void OnPitchMenuSelected();
	void OnVolumeMenuSelected();
	void OnPanMenuSelected();
	void OnEQMenuSelected();
	void OnEQ20MenuSelected();
	void OnEQ25MenuSelected();
	void OnEQ31_5MenuSelected();
	void OnEQ40MenuSelected();
	void OnEQ50MenuSelected();
	void OnEQ63MenuSelected();
	void OnEQ80MenuSelected();
	void OnEQ100MenuSelected();
	void OnEQ125MenuSelected();
	void OnEQ160MenuSelected();
	void OnEQ200MenuSelected();
	void OnEQ250MenuSelected();
	void OnEQ315MenuSelected();
	void OnEQ400MenuSelected();
	void OnEQ500MenuSelected();
	void OnEQ630MenuSelected();
	void OnEQ800MenuSelected();
	void OnEQ1KMenuSelected();
	void OnEQ1_25KMenuSelected();
	void OnEQ1_6KMenuSelected();
	void OnEQ2KMenuSelected();
	void OnEQ2_5KMenuSelected();
	void OnEQ3_15KMenuSelected();
	void OnEQ4KMenuSelected();
	void OnEQ5KMenuSelected();
	void OnEQ6_3KMenuSelected();
	void OnEQ8KMenuSelected();
	void OnEQ10KMenuSelected();
	void OnEQ12_5KMenuSelected();
	void OnEQ16KMenuSelected();
	void OnEQ20KMenuSelected();
	void OnTabMenuSelected();
	void OnPlayListMenuSelected();
	void OnCloseAllMenuSelected();
	void OnHeadMenuSelected();
	void OnPauseMenuSelected();
	void OnPreviousMenuSelected();
	void OnNextMenuSelected();
	void OnStopMenuSelected();
	void OnRewindMenuSelected();
	void OnForwardMenuSelected();
	void OnPauseAndReturn1SecMenuSelected();
	void OnPauseAndReturn2SecMenuSelected();
	void OnPauseAndReturn3SecMenuSelected();
	void OnPauseAndReturn5SecMenuSelected();
	void OnPauseAndReturn10SecMenuSelected();
	void OnReturn1SecMenuSelected();
	void OnReturn2SecMenuSelected();
	void OnReturn3SecMenuSelected();
	void OnReturn5SecMenuSelected();
	void OnReturn10SecMenuSelected();
	void OnForward1SecMenuSelected();
	void OnForward2SecMenuSelected();
	void OnForward3SecMenuSelected();
	void OnForward5SecMenuSelected();
	void OnForward10SecMenuSelected();
	void OnAddPresetMenuSelected();
	void OnDeletePresetMenuSelected();
	void OnPresetMenuSelected(int id);
	void OnResetSpeedMenuSelected();
	void OnSetSpeed50MenuSelected();
	void OnSetSpeed60MenuSelected();
	void OnSetSpeed70MenuSelected();
	void OnSetSpeed80MenuSelected();
	void OnSetSpeed90MenuSelected();
	void OnSetSpeed100MenuSelected();
	void OnSetSpeed110MenuSelected();
	void OnSetSpeed120MenuSelected();
	void OnSetSpeed130MenuSelected();
	void OnSetSpeed140MenuSelected();
	void OnSetSpeed150MenuSelected();
	void OnSetSpeed160MenuSelected();
	void OnSetSpeed170MenuSelected();
	void OnSetSpeed180MenuSelected();
	void OnSetSpeed190MenuSelected();
	void OnSetSpeed200MenuSelected();
	void OnSetSpeed250MenuSelected();
	void OnSetSpeed300MenuSelected();
	void OnSetSpeed350MenuSelected();
	void OnSetSpeed400MenuSelected();
	void OnDown0_1SpeedMenuSelected();
	void OnDown1SpeedMenuSelected();
	void OnDown2SpeedMenuSelected();
	void OnDown3SpeedMenuSelected();
	void OnDown5SpeedMenuSelected();
	void OnDown10SpeedMenuSelected();
	void OnUp0_1SpeedMenuSelected();
	void OnUp1SpeedMenuSelected();
	void OnUp2SpeedMenuSelected();
	void OnUp3SpeedMenuSelected();
	void OnUp5SpeedMenuSelected();
	void OnUp10SpeedMenuSelected();
	void OnSetSpeedDecimal0MenuSelected();
	void OnSetSpeedDecimal1MenuSelected();
	void OnSetSpeedDecimal2MenuSelected();
	void OnResetFreqMenuSelected();
	void OnSetFreq50MenuSelected();
	void OnSetFreq60MenuSelected();
	void OnSetFreq70MenuSelected();
	void OnSetFreq80MenuSelected();
	void OnSetFreq90MenuSelected();
	void OnSetFreq100MenuSelected();
	void OnSetFreq110MenuSelected();
	void OnSetFreq120MenuSelected();
	void OnSetFreq130MenuSelected();
	void OnSetFreq140MenuSelected();
	void OnSetFreq150MenuSelected();
	void OnSetFreq160MenuSelected();
	void OnSetFreq170MenuSelected();
	void OnSetFreq180MenuSelected();
	void OnSetFreq190MenuSelected();
	void OnSetFreq200MenuSelected();
	void OnSetFreq250MenuSelected();
	void OnSetFreq300MenuSelected();
	void OnSetFreq350MenuSelected();
	void OnSetFreq400MenuSelected();
	void OnDown0_1FreqMenuSelected();
	void OnDown1FreqMenuSelected();
	void OnDown2FreqMenuSelected();
	void OnDown3FreqMenuSelected();
	void OnDown5FreqMenuSelected();
	void OnDown10FreqMenuSelected();
	void OnUp0_1FreqMenuSelected();
	void OnUp1FreqMenuSelected();
	void OnUp2FreqMenuSelected();
	void OnUp3FreqMenuSelected();
	void OnUp5FreqMenuSelected();
	void OnUp10FreqMenuSelected();
	void OnSetFreqDecimal0MenuSelected();
	void OnSetFreqDecimal1MenuSelected();
	void OnSetFreqDecimal2MenuSelected();
	void OnResetPitchMenuSelected();
	void OnSetPitchFlat12MenuSelected();
	void OnSetPitchFlat11MenuSelected();
	void OnSetPitchFlat10MenuSelected();
	void OnSetPitchFlat9MenuSelected();
	void OnSetPitchFlat8MenuSelected();
	void OnSetPitchFlat7MenuSelected();
	void OnSetPitchFlat6MenuSelected();
	void OnSetPitchFlat5MenuSelected();
	void OnSetPitchFlat4MenuSelected();
	void OnSetPitchFlat3MenuSelected();
	void OnSetPitchFlat2MenuSelected();
	void OnSetPitchFlat1MenuSelected();
	void OnSetPitchNaturalMenuSelected();
	void OnSetPitchSharp1MenuSelected();
	void OnSetPitchSharp2MenuSelected();
	void OnSetPitchSharp3MenuSelected();
	void OnSetPitchSharp4MenuSelected();
	void OnSetPitchSharp5MenuSelected();
	void OnSetPitchSharp6MenuSelected();
	void OnSetPitchSharp7MenuSelected();
	void OnSetPitchSharp8MenuSelected();
	void OnSetPitchSharp9MenuSelected();
	void OnSetPitchSharp10MenuSelected();
	void OnSetPitchSharp11MenuSelected();
	void OnSetPitchSharp12MenuSelected();
	void OnDown1PitchMenuSelected();
	void OnDown2PitchMenuSelected();
	void OnDown1OctavePitchMenuSelected();
	void OnUp1PitchMenuSelected();
	void OnUp2PitchMenuSelected();
	void OnUp1OctavePitchMenuSelected();
	void OnSetPitchDecimal0MenuSelected();
	void OnSetPitchDecimal1MenuSelected();
	void OnSetPitchDecimal2MenuSelected();
	void OnResetVolumeMenuSelected();
	void OnSetVolume0MenuSelected();
	void OnSetVolume10MenuSelected();
	void OnSetVolume20MenuSelected();
	void OnSetVolume30MenuSelected();
	void OnSetVolume40MenuSelected();
	void OnSetVolume50MenuSelected();
	void OnSetVolume60MenuSelected();
	void OnSetVolume70MenuSelected();
	void OnSetVolume80MenuSelected();
	void OnSetVolume90MenuSelected();
	void OnSetVolume100MenuSelected();
	void OnUpVolumeMenuSelected();
	void OnDownVolumeMenuSelected();
	void OnSingleLoopMenuSelected();
	void OnAllLoopMenuSelected();
	void OnRandomMenuSelected();
	void OnContinueMenuSelected();
	void OnSameArtistMenuSelected();
	void OnABLoopAMenuSelected();
	void OnABLoopASettingMenuSelected();
	void OnABLoopBMenuSelected();
	void OnABLoopBSettingMenuSelected();
	void OnMarkerPlayMenuSelected();
	void OnAddMarkerMenuSelected();
	void OnDeleteMarkerMenuSelected();
	void OnCountLoopMenuSelected();
	void OnInstantLoopMenuSelected();
	void OnSetPositionAutoMenuSelected();
	void OnRecordNoiseMenuSelected();
	void OnWaveMenuSelected();
	void OnNormalizeMenuSelected();
	void OnVocalCancelMenuSelected();
	void OnReverseMenuSelected();
	void OnRecordMenuSelected();
	void OnLowBatteryMenuSelected();
	void OnNoSenseMenuSelected();
	void OnBassCopyMenuSelected();
	void OnDrumsCopyMenuSelected();
	void OnEarTrainingMenuSelected();
	void OnMonoralMenuSelected();
	void OnOnlyLeftMenuSelected();
	void OnOnlyRightMenuSelected();
	void OnChangeLRMenuSelected();
	void OnKeySettingMenuSelected();
	void OnOutKeySettingMenuSelected();
	void OnLimitMenuSelected();
	void OnTimerPlayMenuSelected();
	void OnPlayRangeMenuSelected();
	void OnPlayPositionMenuSelected();
	void OnIncSpeedMenuSelected();
	void OnIncFreqMenuSelected();
	void OnDecSpeedMenuSelected();
	void OnDecFreqMenuSelected();
	void OnFadeoutMenuSelected();
	void OnFadeout1SecMenuSelected();
	void OnFadeout2SecMenuSelected();
	void OnFadeout3SecMenuSelected();
	void OnFadeout4SecMenuSelected();
	void OnFadeout5SecMenuSelected();
	void OnFadeout6SecMenuSelected();
	void OnFadeout7SecMenuSelected();
	void OnFadeout8SecMenuSelected();
	void OnFadeout9SecMenuSelected();
	void OnFadeout10SecMenuSelected();
	void OnFadeoutNextMenuSelected();
	void OnFadeoutNext1SecMenuSelected();
	void OnFadeoutNext2SecMenuSelected();
	void OnFadeoutNext3SecMenuSelected();
	void OnFadeoutNext4SecMenuSelected();
	void OnFadeoutNext5SecMenuSelected();
	void OnFadeoutNext6SecMenuSelected();
	void OnFadeoutNext7SecMenuSelected();
	void OnFadeoutNext8SecMenuSelected();
	void OnFadeoutNext9SecMenuSelected();
	void OnFadeoutNext10SecMenuSelected();
	void OnTweetMenuSelected();
	void OnMetronomeMenuSelected();
	void OnQualityNormalMenuSelected();
	void OnQualityASIOMenuSelected();
	void OnQualityWASAPIMenuSelected();
	void OnReverbDefaultMenuSelected();
	void OnReverbCustomizeMenuSelected();
	void On3DReverbDefaultMenuSelected();
	void On3DReverbPaddedCellMenuSelected();
	void On3DReverbRoomMenuSelected();
	void On3DReverbBathroomMenuSelected();
	void On3DReverbLivingRoomMenuSelected();
	void On3DReverbStoneRoomMenuSelected();
	void On3DReverbAuditoriumMenuSelected();
	void On3DReverbConcertHallMenuSelected();
	void On3DReverbCaveMenuSelected();
	void On3DReverbArenaMenuSelected();
	void On3DReverbHangarMenuSelected();
	void On3DReverbCarpetedHallwayMenuSelected();
	void On3DReverbHallwayMenuSelected();
	void On3DReverbStoneCorridorMenuSelected();
	void On3DReverbAlleyMenuSelected();
	void On3DReverbForestMenuSelected();
	void On3DReverbCityMenuSelected();
	void On3DReverbMountainsMenuSelected();
	void On3DReverbQuarryMenuSelected();
	void On3DReverbPlainMenuSelected();
	void On3DReverbParkingLotMenuSelected();
	void On3DReverbSewerPipeMenuSelected();
	void On3DReverbUnderwaterMenuSelected();
	void On3DReverbSmallRoomMenuSelected();
	void On3DReverbMediumRoomMenuSelected();
	void On3DReverbLargeRoomMenuSelected();
	void On3DReverbMediumHallMenuSelected();
	void On3DReverbLargeHallMenuSelected();
	void On3DReverbPlateMenuSelected();
	void On3DReverbCustomizeMenuSelected();
	void OnDelayDefaultMenuSelected();
	void OnDelayShortMenuSelected();
	void OnDelayMediumMenuSelected();
	void OnDelayLongMenuSelected();
	void OnDelayStereoShortMenuSelected();
	void OnDelayStereoMediumMenuSelected();
	void OnDelayStereoLongMenuSelected();
	void OnDelayMountainMenuSelected();
	void OnDelayBigMenuSelected();
	void OnDelayStereoBigMenuSelected();
	void OnDelayDoublingMenuSelected();
	void OnDelayDoubleKickMenuSelected();
	void OnDelayCustomizeMenuSelected();
	void OnChorusDefaultMenuSelected();
	void OnChorusCustomizeMenuSelected();
	void OnCompressorDefaultMenuSelected();
	void OnCompressorCustomizeMenuSelected();
	void OnFlangerDefaultMenuSelected();
	void OnFlangerCustomizeMenuSelected();
	void OnGargleDefaultMenuSelected();
	void OnGargleCustomizeMenuSelected();
	void OnDistortionDefaultMenuSelected();
	void OnDistortionCustomizeMenuSelected();
	void OnEQFlatMenuSelected();
	void OnEQLowSuperMenuSelected();
	void OnEQLowHighestMenuSelected();
	void OnEQLowHighMenuSelected();
	void OnEQLowMiddleMenuSelected();
	void OnEQLowLowMenuSelected();
	void OnEQLowLowestMenuSelected();
	void OnEQMiddleSuperMenuSelected();
	void OnEQMiddleHighestMenuSelected();
	void OnEQMiddleHighMenuSelected();
	void OnEQMiddleMiddleMenuSelected();
	void OnEQMiddleLowMenuSelected();
	void OnEQMiddleLowestMenuSelected();
	void OnEQHighSuperMenuSelected();
	void OnEQHighHighestMenuSelected();
	void OnEQHighHighMenuSelected();
	void OnEQHighMiddleMenuSelected();
	void OnEQHighLowMenuSelected();
	void OnEQHighLowestMenuSelected();
	void OnEQLowCutSuperMenuSelected();
	void OnEQLowCutHighestMenuSelected();
	void OnEQLowCutHighMenuSelected();
	void OnEQLowCutMiddleMenuSelected();
	void OnEQLowCutLowMenuSelected();
	void OnEQLowCutLowestMenuSelected();
	void OnEQMiddleCutSuperMenuSelected();
	void OnEQMiddleCutHighestMenuSelected();
	void OnEQMiddleCutHighMenuSelected();
	void OnEQMiddleCutMiddleMenuSelected();
	void OnEQMiddleCutLowMenuSelected();
	void OnEQMiddleCutLowestMenuSelected();
	void OnEQHighCutSuperMenuSelected();
	void OnEQHighCutHighestMenuSelected();
	void OnEQHighCutHighMenuSelected();
	void OnEQHighCutMiddleMenuSelected();
	void OnEQHighCutLowMenuSelected();
	void OnEQHighCutLowestMenuSelected();
	void OnResetAllMenuSelected();
	void OnDoubleRunMenuSelected();
	void OnTopMostMenuSelected();
	void OnTaskTrayMenuSelected();
	void OnCopyTimeMenuSelected();
	void OnManualMenuSelected();
	void OnUpdateCheckMenuSelected();
	void OnVersionInfoMenuSelected();
	void OnRestoreMenuSelected();

	CMenu & GetPresetMenu() {
		return m_presetMenu;
	}

private: // oϐ

	CApp & m_rApp;
	CMainWnd & m_rMainWnd;

	CMenu m_fileMenu;
	CMenu m_editMenu;
	CMenu m_viewMenu;
	CMenu m_videoScreenMenu;
	CMenu m_eqMenu;
	CMenu m_toolbarMenu;
	CMenu m_playMenu;
	CMenu m_returnMenu;
	CMenu m_forwardMenu;
	CMenu m_presetMenu;
	CMenu m_speedMenu;
	CMenu m_freqMenu;
	CMenu m_pitchMenu;
	CMenu m_volumeMenu;
	CMenu m_systemMenu;
	CMenu m_recoveryMenu;
	CMenu m_recoverVisibleMenu;
	CMenu m_recoverPlayModeMenu;
	CMenu m_effectMenu;
	CMenu m_setSpeedMenu;
	CMenu m_setFreqMenu;
	CMenu m_setPitchMenu;
	CMenu m_setVolumeMenu;
	CMenu m_speedDecimalMenu;
	CMenu m_freqDecimalMenu;
	CMenu m_pitchDecimalMenu;
	CMenu m_reverbMenu;
	CMenu m_3dreverbMenu;
	CMenu m_delayMenu;
	CMenu m_chorusMenu;
	CMenu m_compressorMenu;
	CMenu m_flangerMenu;
	CMenu m_gargleMenu;
	CMenu m_distortionMenu;
	CMenu m_eqPresetMenu;
	CMenu m_soundEffectMenu;
	CMenu m_fadeoutMenu;
	CMenu m_fadeoutNextMenu;
	CMenu m_qualityMenu;
	CMenu m_helpMenu;
};
//----------------------------------------------------------------------------

#endif