//----------------------------------------------------------------------------
// RMenu_Explorer.cpp : GNXv[pENbNj[̊Ǘs
//----------------------------------------------------------------------------
#include <windows.h>
#include "MainWnd.h"
#include "Explorer.h"
#include "RMenu_Explorer.h"
//----------------------------------------------------------------------------
// 쐬
//----------------------------------------------------------------------------
BOOL CRMenu_Explorer::Create(BOOL bOnItem)
{
	CMenu::CreatePopup();

	if(bOnItem) {
#if JP
		Append(MFS_ENABLED, ID_OPEN, _T("J(&O)"));
		Append(MFS_ENABLED, ID_ADD, _T("ǉ(&A)"));
#else // JP
		Append(MFS_ENABLED, ID_OPEN, _T("Open(&O)"));
		Append(MFS_ENABLED, ID_ADD, _T("Add(&A)"));
#endif // JP

		AppendSeparator();
#if JP
		Append(MFS_ENABLED, ID_OPENFOLDER, _T("tH_J(&O)"));
		Append(MFS_ENABLED, ID_PROPERTIES, _T("vpeB(&R)"));
#else // JP
		Append(MFS_ENABLED, ID_OPENFOLDER, _T("Open Folder(&O)"));
		Append(MFS_ENABLED, ID_PROPERTIES, _T("Properties(&R)"));
#endif // JP
		AppendSeparator();
	}
#if JP
	Append(MF_CHECKED, ID_VISIBLE, _T("GNXv[̕\(&V)"));
#else // JP
	Append(MF_CHECKED, ID_VISIBLE, _T("Show Exploler(&S)"));
#endif // JP

	if(!m_hMenu) return FALSE;
	return TRUE;
}
//----------------------------------------------------------------------------
// j[Iꂽ
//----------------------------------------------------------------------------
void CRMenu_Explorer::OnCommand(int id, HWND/* hwndCtl*/, UINT/* codeNotify*/)
{
	if(id == ID_OPEN) OnOpenFilesMenuSelected();
	else if(id == ID_ADD) OnAddFilesMenuSelected();
	else if(id == ID_OPENFOLDER) OnOpenFolderMenuSelected();
	else if(id == ID_PROPERTIES) OnPropertiesMenuSelected();
	else if(id == ID_VISIBLE) OnVisibleMenuSelected();
}
//----------------------------------------------------------------------------
// Jj[Iꂽ
//----------------------------------------------------------------------------
void CRMenu_Explorer::OnOpenFilesMenuSelected()
{
	m_rParent.OpenFiles(TRUE);
}
//----------------------------------------------------------------------------
// ǉj[Iꂽ
//----------------------------------------------------------------------------
void CRMenu_Explorer::OnAddFilesMenuSelected()
{
	m_rParent.OpenFiles(FALSE);
}
//----------------------------------------------------------------------------
// tH_Jj[Iꂽ
//----------------------------------------------------------------------------
void CRMenu_Explorer::OnOpenFolderMenuSelected()
{
	m_rParent.OpenFolder();
}
//----------------------------------------------------------------------------
// vpeBj[Iꂽ
//----------------------------------------------------------------------------
void CRMenu_Explorer::OnPropertiesMenuSelected()
{
	m_rParent.ShowProperties();
}
//----------------------------------------------------------------------------
// GNXv[̕\j[Iꂽ
//----------------------------------------------------------------------------
void CRMenu_Explorer::OnVisibleMenuSelected()
{
	m_rParent.GetMainWnd().GetMenu().OnExplorerMenuSelected();
}
//----------------------------------------------------------------------------
